import { ScrollView, View, Button } from '@tarojs/components'
import Taro from '@tarojs/taro';
import { useState, useEffect } from 'react';
import { getOrder } from '@/services/dogAPI';
import './style.less'

export default (props) => {
  const id = Taro.getCurrentInstance().router.params.id;
  const [orderInfo, setOrderInfo] = useState()

  useEffect(() => {
    if (id) {
      getOrder(id).then((e) => {
        console.log('e', e);
        setOrderInfo(e)
      })
    }

  }, [id])

  const pay = (params) => {
    Taro.hideLoading()
    console.log("🚀 ~ file: index.jsx ~ line 92 ~ requestPayment ~ params", params)
    Taro.requestPayment({
      // ...params,
      // package: params.packageValue,
      success: () => {
        Taro.showToast({
          title: "支付成功",
          icon: "success",
          duration: 1000,
        }).then(() => {
          setTimeout(() => {
            Taro.reLaunch({
              url: `/pages/index/index?tab=2`
            })
          }, 400)
        })
      },
      fail: (e) => {
        Taro.showToast({
          title: "支付失败",
          icon: "none",
          duration: 2000,
        });
        Taro.reLaunch({
          // url: `/pages/MineUserAll/AllOrder/index?tabJump=1`
        })
      },
    })
  }

  return (
    <ScrollView scrollY style={{ height: '100vh' }}>
      <View className='payPageBox'>
        <View className='payPageBox-payItemBox'>
          <View className='payPageBox-payItemBox-left'></View>
          <View className='payPageBox-payItemBox-content'>订单号： <View>32121321321</View></View>
        </View>
        <View className='payPageBox-payItemBox'>
          <View className='payPageBox-payItemBox-leftText'>工本费： <View>20</View>元</View>
        </View>
        <View className='payPageBox-payItemBox'>
          <View className='payPageBox-payItemBox-leftText'>快递费： <View>3221321</View>元</View>
        </View>
        <View className='payPageBox-payItemBox'>
          <View className='payPageBox-payItemBox-leftText'>总金额： <View style={{ color: 'red' }}>20</View>元</View>
        </View>
      </View>
      <View slot='button' style={{ margin: '4em 0 2em 0' }}>
        <Button style={{ backgroundColor: '#fbd804', borderRadius: '40px', color: '#000', border: '0px' }} class='weui-btn' type='primary' loading={false} onClick={pay}>支付</Button>
      </View>
    </ScrollView>
  )
}