import { View, Button, Text, RadioGroup, Picker, Image, Input, Radio, Label, ScrollView } from '@tarojs/components'
import Taro, { useDidShow } from '@tarojs/taro';
import { useState } from 'react';
import Form from '@/components/Form';
import AuthProfile from '@/components/Authorize/AuthProfile';

import { addDogList, addlication, getDogInfo } from '../../services/dogAPI';
import { useModel } from '../../store';

import './style.less'
import { uploadFile } from '../../utils/request';

export default (props) => {
  const { dogs, person } = useModel('userData')
  const [formData, setFormData] = useState()

  const [dogDate, setDogDate] = useState({ immunizationDate: '请选择日期', petBirthday: '请选择生日', petSex: [], petType: [] })
  const [imgUrl, setImgUrl] = useState({ img1: null, immunizationImg: null })
  const [mainDog, setMainDog] = useState([])
  useDidShow(() => {
    addDogList().then((res) => {
      setMainDog(res.records)
    })
  }, [])

  const getMainDogChange = (value) => {
    console.log("🚀 ~ file: index.jsx ~ line 34 ~ getMainDogChange ~ value", value)
    const { petId } = value.detail.data

    getDogInfo(petId).then((e) => {
      setFormData(e)
      const sex = [{ value: e?.sex, text: e?.sex == 1 ? '雄' : '雌' }];
      const petType = [{ value: 0, name: e?.petType }];

      setDogDate({ ...dogDate, petBirthday: e?.birthday, petSex: sex, petType: petType })
      setImgUrl({ ...imgUrl, img1: e.image })
      console.log('test', e);

    })
  }



  const onDateChange = (type, value) => {
    console.log('dogDate', dogDate);

    switch (type) {
      case 'petSex':
        setDogDate({ ...dogDate, petSex: value })
        break;
      case 'petBirthday':
        setDogDate({ ...dogDate, petBirthday: value })
        break;
      case 'petType':
        setDogDate({ ...dogDate, petType: value })
        break;
      case 'immunizationDate':
        setDogDate({ ...dogDate, immunizationDate: value })
        break;
      default:
        break;
    }
  }

  const modeList = [
    {
      value: 1,
      text: '邮寄',
    },
    {
      value: 2,
      text: '自取',
    },

  ]

  const addImage = (e) => {

    if (e == 'img1') {
      Taro.chooseImage({
        count: 1, // 默认9
        sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
        sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有，在H5浏览器端支持使用 `user` 和 `environment`分别指定为前后摄像头
        success: function (res) {
          // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
          var tempFilePaths = res.tempFilePaths
          uploadFile(tempFilePaths[0]).then((res2) => {
            console.log("🚀 ~ file: index.jsx ~ line 61 ~ uploadFile ~ res2", res2)
            setImgUrl({ ...imgUrl, img1: res2 })


          })
        },
        fail () {
          Taro.showToast({
            title: '上传失败请重试',
            icon: 'error',
            duration: 1000
          })
        }
      })

    } else {
      Taro.chooseImage({
        count: 1, // 默认9
        sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
        sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有，在H5浏览器端支持使用 `user` 和 `environment`分别指定为前后摄像头
        success: function (res) {
          // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
          var tempFilePaths = res.tempFilePaths
          uploadFile(tempFilePaths[0]).then((res2) => {
            console.log("🚀 ~ file: index.jsx ~ line 61 ~ uploadFile ~ res2", res2)
            setImgUrl({ ...imgUrl, immunizationImg: res2 })


          })
        },
        fail () {
          Taro.showToast({
            title: '上传失败请重试',
            icon: 'error',
            duration: 1000
          })
        }
      })
    }


  }
  // ...dogDate,
  const formSubmit = value => {
    addlication({ ...value, ...imgUrl, applyType: 'first' }).then((res) => {
      console.log('dogInfo xinwe', res);
      Taro.showToast({
        title: '保存成功',
        icon: 'none',
        duration: 1000
      })
      Taro.navigateTo({
        url: `/pages/payPage/index?id=${res.applyId}`
      })
    })
  }



  return (
    <ScrollView scrollY style={{ height: '100vh' }} >
      <AuthProfile />
      <View class='page' >
        <Form onSubmit={formSubmit} >
          <mp-form  >
            <mp-cells >
              <mp-cell title='犬主姓名' extClass=''>
                <View >{person?.nickName}</View>
              </mp-cell>
              <mp-cell title='狗狗名称' extClass=''>
                {/* <Input name='petName' placeholder='请输入狗狗名称' /> */}
                <s-picker name='petName' rangeKey='name' rangeValue='value' range={mainDog} value={formData?.name} onChange={getMainDogChange} />
                <View onClick={onDateChange}>log打印</View>
                {/* <Picker name='petSex' mode='selector' range={selector} onChange={(e) => { onDateChange('petSex', e.detail.value) }}>
                  <View className='picker'>
                    {dogDate.petSex}
                  </View>
                </Picker> */}
              </mp-cell>
              <mp-cell title='狗狗性别' extClass=''>
                <s-picker name='petSex' rangeKey='text' rangeValue='value' range={dogDate.petSex} value={formData?.sex} />
              </mp-cell>
              <mp-cell title='犬种' extClass=''>
                <s-picker name='petType' rangeKey='name' rangeValue='name' range={dogDate.petType} value={formData?.petType} />
              </mp-cell>
              <mp-cell title='生日' extClass=''>
                <Picker name='petBirthday' mode='date' onChange={(e) => { onDateChange('petBirthday', e.detail.value) }}>
                  <View className='picker' style={!formData ? { "color": '#858585' } : {}}>
                    {dogDate.petBirthday}
                  </View>
                </Picker>
              </mp-cell>
              <mp-cell title='毛色' extClass=''>
                <Input name='petColor' placeholder='请输入毛色' value={formData?.color} />
              </mp-cell>
              <mp-cell title='狗狗照片' extClass=''>
                {
                  !imgUrl.img1 ?
                    <View className='addImage' onClick={() => addImage('img1')} >
                      <Text>+</Text>
                    </View>
                    :
                    <Image className='dogImg1' name='img1' src={imgUrl.img1} onClick={() => addImage('img1')} />
                }

              </mp-cell>
              <mp-cell title='最近免疫日期' extClass=''>
                <Picker name='immunizationDate' mode='date' onChange={(e) => { onDateChange('immunizationDate', e.detail.value) }}>
                  <View className='picker' style={!formData ? { "color": '#858585' } : {}}>
                    {dogDate.immunizationDate}
                  </View>
                </Picker>
              </mp-cell>
              <mp-cell title='免疫证号' extClass=''>
                <Input name='immunizationCode' placeholder='请输入免疫证号' />
              </mp-cell>
              <mp-cell title='免疫证明' extClass=''>
                {
                  !imgUrl.immunizationImg ?
                    <View className='addImage' onClick={() => addImage('immunizationImg')} >
                      <Text>+</Text>
                    </View>
                    :
                    <Image className='dogImg1' name='immunizationImg' src={imgUrl.immunizationImg} onClick={() => addImage('immunizationImg')} />
                }
                {/* <Input name='immunizationImg' placeholder='请输入身份证号' type='idcard' /> */}
              </mp-cell>
              <mp-cell title='详细地址' extClass=''>
                <Input name='address' placeholder='请输入详细地址' />
              </mp-cell>
              <mp-cell title='申领方式' extClass=''>
                <View className='radio-list'>
                  <RadioGroup name='applyMethod'>
                    {modeList.map((item, i) => {
                      return (
                        <Label className='radio-list__label' for={i} key={i}>
                          <Radio color='#FCD905' className='radio-list__radio' value={item.value} >{item.text}</Radio>
                        </Label>
                      )
                    })}
                  </RadioGroup>
                </View>
              </mp-cell>

            </mp-cells>
          </mp-form>
          <View slot='button' style={{ margin: '4em 0 2em 0' }}>
            <Button style={{ backgroundColor: '#fbd804', borderRadius: '40px', color: '#000', border: '0px' }} class='weui-btn' type='primary' loading={false} formType='submit'>确定</Button>
          </View>
        </Form>
      </View>
    </ScrollView >
  )
}




